// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"UnXq":[function(require,module,exports) {
"use strict";

var __spreadArrays = this && this.__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;

  for (var r = Array(s), k = 0, i = 0; i < il; i++) for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) r[k] = a[j];

  return r;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.includes = exports.isObject = exports.convertToArray = exports.getParam = exports.cleanPath = void 0; // ------ ROUTER FUNCTIONS ---------

function cleanPath(path) {
  // remove leading/trailing slashes + hash symbol
  // e.g: '#////posts/:id///' -> posts/:id
  return path.replace(/^[\#]*[\/]*(.*)/, '$1').replace(/\/+$/, '');
}

exports.cleanPath = cleanPath;

function getParam(paramName, url) {
  var href = url || window.location.href;
  var name = paramName.replace(/[[]]/g, '\\$&');
  var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)");
  var results = regex.exec(href);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

exports.getParam = getParam; // -------- COMMON FUNCTIONS ----------

function convertToArray(arr) {
  return __spreadArrays(arr);
}

exports.convertToArray = convertToArray;

function isObject(obj) {
  return typeof obj === 'object';
}

exports.isObject = isObject;

function includes(arr, id) {
  return arr.indexOf(id) !== -1;
}

exports.includes = includes;
},{}],"QCba":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRouter = void 0;

var utils_1 = require("./utils");

var REGEX_PARAMS = /([:*])(\w+)/g;
var REGEX_REPLACE_VAR = '([^/]+)';

function onRouterChange(fn) {
  window.addEventListener('hashchange', function () {
    fn();
  });
}

function go(path) {
  window.location.hash = '#' + path;
}

function useRouter(routesArray) {
  var _params = Object.create(null);

  var routes = Object.create(null);
  var currentComponent = null;

  for (var _i = 0, routesArray_1 = routesArray; _i < routesArray_1.length; _i++) {
    var r = routesArray_1[_i];
    r.path = utils_1.cleanPath(r.path);
    routes[r.path] = r.component;
  }

  function getPath() {
    return utils_1.cleanPath(location.hash);
  }

  function regexToParams(match, names) {
    if (names.length === 0) return null;
    if (!match) return null; // filter params, skip full match string -> params mapping

    var matchInfo = match.slice(1, match.length);
    return matchInfo.reduce(function (paramObj, value, index) {
      var name = names[index];
      paramObj[name] = value;
      return paramObj;
    }, {});
  }

  function createParamsPattern(routerPath) {
    // posts/:id -> posts/([^/]+)
    var paramNames = [];
    var pattern = routerPath.replace(REGEX_PARAMS, function (_1, _2, name) {
      paramNames.push(name);
      return REGEX_REPLACE_VAR;
    });
    return {
      paramNames: paramNames,
      pattern: pattern
    };
  }

  function match(browserPath) {
    if (utils_1.isObject(routes[browserPath])) {
      currentComponent = routes[browserPath];
      return routes[browserPath];
    } // Assign url params


    _params = Object.create(null);

    for (var _i = 0, _a = Object.keys(routes); _i < _a.length; _i++) {
      var routerPath = _a[_i]; // browserPath = 'posts/37739';
      // routerPath = 'posts/:id'

      if (utils_1.includes(routerPath, ':')) {
        var _b = createParamsPattern(routerPath),
            pattern = _b.pattern,
            paramNames = _b.paramNames;

        var regexp = new RegExp(pattern);
        var match_1 = browserPath.match(regexp);

        if (match_1) {
          _params = regexToParams(match_1, paramNames);
          currentComponent = routes[routerPath];
          return routes[routerPath];
        }
      }
    } // Handle 404


    if (utils_1.isObject(routes['*'])) {
      currentComponent = routes['*'];
      return routes[browserPath];
    }

    var default404Route = {
      render: function render() {
        return "Not found";
      }
    };
    currentComponent = default404Route;
    return default404Route;
  }

  function routerContextFn() {
    return {
      params: function params() {
        return _params;
      },
      go: go
    };
  }

  function renderer(render, forceUnmount) {
    onRouterChange(function () {
      if (currentComponent) {
        forceUnmount(currentComponent);
      }

      render(match(getPath()));
    });
    render(match(getPath()));
  }

  return {
    renderer: renderer,
    routerContextFn: routerContextFn
  };
}

exports.createRouter = useRouter;
exports.default = {
  createRouter: exports.createRouter
};
},{"./utils":"UnXq"}]},{},["QCba"], null)