(function () {
// ASSET: utils.ts
var $UnXq$exports = {};

var $UnXq$var$__spreadArrays = $UnXq$exports && $UnXq$exports.__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;

  for (var r = Array(s), k = 0, i = 0; i < il; i++) for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) r[k] = a[j];

  return r;
};

Object.defineProperty($UnXq$exports, "__esModule", {
  value: true
});
var $UnXq$export$includes = ($UnXq$export$isObject = ($UnXq$export$convertToArray = ($UnXq$export$getParam = ($UnXq$export$cleanPath = void 0, $UnXq$exports.cleanPath = $UnXq$export$cleanPath), $UnXq$exports.getParam = $UnXq$export$getParam), $UnXq$exports.convertToArray = $UnXq$export$convertToArray), $UnXq$exports.isObject = $UnXq$export$isObject);
$UnXq$exports.includes = $UnXq$export$includes; // ------ ROUTER FUNCTIONS ---------

function $UnXq$var$cleanPath(path) {
  // remove leading/trailing slashes + hash symbol
  // e.g: '#////posts/:id///' -> posts/:id
  return path.replace(/^[\#]*[\/]*(.*)/, '$1').replace(/\/+$/, '');
}

var $UnXq$export$cleanPath = $UnXq$var$cleanPath;
$UnXq$exports.cleanPath = $UnXq$export$cleanPath;

function $UnXq$var$getParam(paramName, url) {
  var href = url || window.location.href;
  var name = paramName.replace(/[[]]/g, '\\$&');
  var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)");
  var results = regex.exec(href);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

var $UnXq$export$getParam = $UnXq$var$getParam;
$UnXq$exports.getParam = $UnXq$export$getParam; // -------- COMMON FUNCTIONS ----------

function $UnXq$var$convertToArray(arr) {
  return $UnXq$var$__spreadArrays(arr);
}

var $UnXq$export$convertToArray = $UnXq$var$convertToArray;
$UnXq$exports.convertToArray = $UnXq$export$convertToArray;

function $UnXq$var$isObject(obj) {
  return typeof obj === 'object';
}

var $UnXq$export$isObject = $UnXq$var$isObject;
$UnXq$exports.isObject = $UnXq$export$isObject;

function $UnXq$var$includes(arr, id) {
  return arr.indexOf(id) !== -1;
}

$UnXq$export$includes = $UnXq$var$includes;
$UnXq$exports.includes = $UnXq$export$includes;
// ASSET: index.ts
var $QCba$exports = {};
Object.defineProperty($QCba$exports, "__esModule", {
  value: true
});
var $QCba$export$createRouter = void 0;
$QCba$exports.createRouter = $QCba$export$createRouter;
var $QCba$var$REGEX_PARAMS = /([:*])(\w+)/g;
var $QCba$var$REGEX_REPLACE_VAR = '([^/]+)';

function $QCba$var$onRouterChange(fn) {
  window.addEventListener('hashchange', function () {
    fn();
  });
}

function $QCba$var$go(path) {
  window.location.hash = '#' + path;
}

function $QCba$var$useRouter(routesArray) {
  var _params = Object.create(null);

  var routes = Object.create(null);
  var currentComponent = null;

  for (var _i = 0, routesArray_1 = routesArray; _i < routesArray_1.length; _i++) {
    var r = routesArray_1[_i];
    r.path = $UnXq$export$cleanPath(r.path);
    routes[r.path] = r.component;
  }

  function getPath() {
    return $UnXq$export$cleanPath(location.hash);
  }

  function regexToParams(match, names) {
    if (names.length === 0) return null;
    if (!match) return null; // filter params, skip full match string -> params mapping

    var matchInfo = match.slice(1, match.length);
    return matchInfo.reduce(function (paramObj, value, index) {
      var name = names[index];
      paramObj[name] = value;
      return paramObj;
    }, {});
  }

  function createParamsPattern(routerPath) {
    // posts/:id -> posts/([^/]+)
    var paramNames = [];
    var pattern = routerPath.replace($QCba$var$REGEX_PARAMS, function (_1, _2, name) {
      paramNames.push(name);
      return $QCba$var$REGEX_REPLACE_VAR;
    });
    return {
      paramNames: paramNames,
      pattern: pattern
    };
  }

  function match(browserPath) {
    if ($UnXq$export$isObject(routes[browserPath])) {
      currentComponent = routes[browserPath];
      return routes[browserPath];
    } // Assign url params


    _params = Object.create(null);

    for (var _i = 0, _a = Object.keys(routes); _i < _a.length; _i++) {
      var routerPath = _a[_i]; // browserPath = 'posts/37739';
      // routerPath = 'posts/:id'

      if ($UnXq$export$includes(routerPath, ':')) {
        var _b = createParamsPattern(routerPath),
            pattern = _b.pattern,
            paramNames = _b.paramNames;

        var regexp = new RegExp(pattern);
        var match_1 = browserPath.match(regexp);

        if (match_1) {
          _params = regexToParams(match_1, paramNames);
          currentComponent = routes[routerPath];
          return routes[routerPath];
        }
      }
    } // Handle 404


    if ($UnXq$export$isObject(routes['*'])) {
      currentComponent = routes['*'];
      return routes[browserPath];
    }

    var default404Route = {
      render: function render() {
        return "Not found";
      }
    };
    currentComponent = default404Route;
    return default404Route;
  }

  function routerContextFn() {
    return {
      params: function params() {
        return _params;
      },
      go: $QCba$var$go
    };
  }

  function renderer(render, forceUnmount) {
    $QCba$var$onRouterChange(function () {
      if (currentComponent) {
        forceUnmount(currentComponent);
      }

      render(match(getPath()));
    });
    render(match(getPath()));
  }

  return {
    renderer: renderer,
    routerContextFn: routerContextFn
  };
}

$QCba$export$createRouter = $QCba$var$useRouter;
$QCba$exports.createRouter = $QCba$export$createRouter;
var $QCba$export$default = {
  createRouter: $QCba$export$createRouter
};
$QCba$exports.default = $QCba$export$default;

if (typeof exports === "object" && typeof module !== "undefined") {
  // CommonJS
  module.exports = $QCba$exports;
} else if (typeof define === "function" && define.amd) {
  // RequireJS
  define(function () {
    return $QCba$exports;
  });
} else {
  // <script>
  this["RactixRouter"] = $QCba$exports;
}
})();