"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.includes = exports.isObject = exports.convertToArray = exports.getParam = exports.cleanPath = void 0;
// ------ ROUTER FUNCTIONS ---------
function cleanPath(path) {
    // remove leading/trailing slashes + hash symbol
    // e.g: '#////posts/:id///' -> posts/:id
    return path.replace(/^[\#]*[\/]*(.*)/, '$1').replace(/\/+$/, '');
}
exports.cleanPath = cleanPath;
function getParam(paramName, url) {
    var href = url || window.location.href;
    var name = paramName.replace(/[[]]/g, '\\$&');
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)");
    var results = regex.exec(href);
    if (!results)
        return null;
    if (!results[2])
        return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}
exports.getParam = getParam;
// -------- COMMON FUNCTIONS ----------
function convertToArray(arr) {
    return __spreadArrays(arr);
}
exports.convertToArray = convertToArray;
function isObject(obj) {
    return typeof obj === 'object';
}
exports.isObject = isObject;
function includes(arr, id) {
    return arr.indexOf(id) !== -1;
}
exports.includes = includes;
